

ECHO.>>%LogPath%
ECHO %DATE% %TIME%[Log START]  ============ [SUB]%~dpnx0 ============ >> %LogPath%
SETLOCAL ENABLEDELAYEDEXPANSION
Pushd "%~dp0"


ECHO %DATE% %TIME%[Log TRACE]  call :%1 >>%LogPath%
call :%1

::::	2016/8/15
::::	UserAlaunch1st_Initialize.cmd will active the High Performance Power plan
::::	Power Management will active the actually Power plan in First Boot

::::	2017/4/6
::::	PredatorSense will control power plan for Predator image after installed and record the power plan when user revise power plan
::::		---- PredatorSense spec : active High Performance for AC mode; Balanced for DC mode 
::::
::::	When Restore Index Valude at FirstBoot, Module active High performance power plan, PredatorSense will treat as End user's behavior then record
::::	If user process OOBE on DC mode, after OOBE, PredatorSense will record User's DC mode set as High performance (violate the spec)
::::	Check current power plan first, then active high performance only
ECHO %DATE% %TIME%[Log TRACE]  POWERCFG /l >>%LogPath%
POWERCFG /l >>%LogPath%
POWERCFG /q >GetCurrentPlan.txt
ECHO %DATE% %TIME%[Log TRACE]  FIND /I "381b4222-f694-41f0-9685-ff5bb260df2e" GetCurrentPlan.txt >>%LogPath% 2>&1
FIND /I "381b4222-f694-41f0-9685-ff5bb260df2e" GetCurrentPlan.txt >>%LogPath% 2>&1
if %errorlevel% equ 0 (
	ECHO !DATE! !TIME![Log TRACE]  Current plan is Balanced, do nothing. >>%LogPath%
) else (
	ECHO !DATE! !TIME![Log TRACE]  Active High Performance Power Plan again after revised the Index Value >>%LogPath%
	ECHO !DATE! !TIME![Log TRACE]  POWERCFG -SETACTIVE %HighPer_GUID% >>%LogPath% 2>&1
	POWERCFG -SETACTIVE %HighPer_GUID% >>%LogPath% 2>&1
)

popd
SETLOCAL DISABLEDELAYEDEXPANSION
ECHO %DATE% %TIME%[Log LEAVE]  ============ [SUB]%~dpnx0 ============ >> %LogPath%
exit /b 0



:Disable
Powercfg.exe /qh >c:\OEM\Preload\Powercfg_BeforeDisable.txt
::::	--- Lid Close No Action ---
::::	Subgroup GUID: 4f971e89-eebd-4455-a8de-9e59040e7347  (Power buttons and lid)
::::		Power Setting GUID: 5ca83367-6e45-459f-a27b-476b1d01c936  (Lid close action)
ECHO %DATE% %TIME%[Log TRACE]  find /i "Product=NB" %FindingPath% >>%LogPath% 2>&1
find /i "Product=NB" %FindingPath% >>%LogPath% 2>&1
if %errorlevel% equ 0 (
	ECHO !DATE! !TIME![Log TRACE]  Powercfg.exe -setACvalueindex Lid Close No Action >> %LogPath% 2>&1
	Powercfg.exe -setACvalueindex %HighPer_GUID% 4f971e89-eebd-4455-a8de-9e59040e7347 5ca83367-6e45-459f-a27b-476b1d01c936 0 >> %LogPath% 2>&1
	ECHO !DATE! !TIME![Log TRACE]  Powercfg.exe -setDCvalueindex Lid Close No Action >> %LogPath% 2>&1
	Powercfg.exe -setDCvalueindex %HighPer_GUID% 4f971e89-eebd-4455-a8de-9e59040e7347 5ca83367-6e45-459f-a27b-476b1d01c936 0 >> %LogPath% 2>&1
) else (
	ECHO !DATE! !TIME![Log TRACE]  Not NB image, no set Lid Close action >>%LogPath%
)
::::	--- Never Sleep ---
::::	Subgroup GUID: 238c9fa8-0aad-41ed-83f4-97be242c8f20  (Sleep)
::::	    Power Setting GUID: 29f6c1db-86da-48c5-9fdb-f2b67b1f44da  (Sleep after)

ECHO %DATE% %TIME%[Log TRACE]  REG QUERY HKLM\SYSTEM\ControlSet001\Control\Power\User\PowerSchemes\%HighPer_GUID%\238c9fa8-0aad-41ed-83f4-97be242c8f20\29f6c1db-86da-48c5-9fdb-f2b67b1f44da /v ACSettingIndex >>%LogPath%
REG QUERY HKLM\SYSTEM\ControlSet001\Control\Power\User\PowerSchemes\%HighPer_GUID%\238c9fa8-0aad-41ed-83f4-97be242c8f20\29f6c1db-86da-48c5-9fdb-f2b67b1f44da /v ACSettingIndex >>%LogPath% 2>&1
for /f "tokens=3 delims= " %%D in ('REG QUERY HKLM\SYSTEM\ControlSet001\Control\Power\User\PowerSchemes\%HighPer_GUID%\238c9fa8-0aad-41ed-83f4-97be242c8f20\29f6c1db-86da-48c5-9fdb-f2b67b1f44da /v ACSettingIndex') do (
	:::: SET /a ACvalueindex=%%D + 0 -- Returning the Decimal value of a registry key instead of its HEX value
	SET /a ACvalueindex=%%D + 0
	if !ACvalueindex! EQU 0 (
		ECHO !DATE! !TIME![Log TRACE]  the ACvalueindex is [!ACvalueindex!], Do nothing.>>%LogPath%
	) ELSE (
		ECHO !DATE! !TIME![Log TRACE]  ECHO [HEX:%%D DEC:!ACvalueindex!] to ACSleepIndex.txt >>%LogPath%
		ECHO !ACvalueindex!>ACSleepIndex.txt
		ECHO !DATE! !TIME![Log TRACE]  Powercfg.exe -setACvalueindex Sleep as Never >>%LogPath%
		Powercfg.exe -setACvalueindex %HighPer_GUID% 238c9fa8-0aad-41ed-83f4-97be242c8f20 29f6c1db-86da-48c5-9fdb-f2b67b1f44da 0 >> %LogPath% 2>&1
	)
)

ECHO %DATE% %TIME%[Log TRACE]  REG QUERY HKLM\SYSTEM\ControlSet001\Control\Power\User\PowerSchemes\%HighPer_GUID%\238c9fa8-0aad-41ed-83f4-97be242c8f20\29f6c1db-86da-48c5-9fdb-f2b67b1f44da /v DCSettingIndex  >> %LogPath% 2>&1
REG QUERY HKLM\SYSTEM\ControlSet001\Control\Power\User\PowerSchemes\%HighPer_GUID%\238c9fa8-0aad-41ed-83f4-97be242c8f20\29f6c1db-86da-48c5-9fdb-f2b67b1f44da /v DCSettingIndex >> %LogPath% 2>&1
for /f "tokens=3 delims= " %%D in ('REG QUERY HKLM\SYSTEM\ControlSet001\Control\Power\User\PowerSchemes\%HighPer_GUID%\238c9fa8-0aad-41ed-83f4-97be242c8f20\29f6c1db-86da-48c5-9fdb-f2b67b1f44da /v DCSettingIndex') do (
	SET /a DCvalueindex=%%D + 0
	if !DCvalueindex! EQU 0 (
		ECHO !DATE! !TIME![Log TRACE]  the DCvalueindex is [!DCvalueindex!], Do nothing.>>%LogPath%
	) ELSE (
		ECHO !DATE! !TIME![Log TRACE]  ECHO [HEX:%%D DEC:!DCvalueindex!] to DCSleepIndex.txt >>%LogPath%
		ECHO !DCvalueindex!>DCSleepIndex.txt
		ECHO !DATE! !TIME![Log TRACE]  Powercfg.exe -setDCvalueindex Sleep as Never >>%LogPath%
		Powercfg.exe -setDCvalueindex %HighPer_GUID% 238c9fa8-0aad-41ed-83f4-97be242c8f20 29f6c1db-86da-48c5-9fdb-f2b67b1f44da 0 >> %LogPath% 2>&1
	)
)
Powercfg.exe /qh >c:\OEM\Preload\Powercfg_AfterDisable.txt
ECHO %DATE% %TIME%[Log TRACE]  copy /y RestoreAcerPowerPlan.cmd C:\Recovery\OEM\RestoreOEMCustomize\RestoreCMD >>%LogPath% 2>&1
copy /y RestoreAcerPowerPlan.cmd C:\Recovery\OEM\RestoreOEMCustomize\RestoreCMD >>%LogPath% 2>&1
exit /b 0


:Restore
Powercfg.exe /qh >c:\OEM\Preload\Powercfg_BeforeRestore.txt
ECHO %DATE% %TIME%[Log TRACE]  find /i "Product=NB" %FindingPath% >>%LogPath% 2>&1
find /i "Product=NB" %FindingPath% >>%LogPath% 2>&1
if %errorlevel% equ 0 (
	ECHO !DATE! !TIME![Log TRACE]  Powercfg.exe -setACvalueindex Lid Close Action - Sleep >> %LogPath% 2>&1
	Powercfg.exe -setACvalueindex %HighPer_GUID% 4f971e89-eebd-4455-a8de-9e59040e7347 5ca83367-6e45-459f-a27b-476b1d01c936 1 >> %LogPath% 2>&1
	ECHO !DATE! !TIME![Log TRACE]  Powercfg.exe -setDCvalueindex Lid Close Action - Sleep >> %LogPath% 2>&1
	Powercfg.exe -setDCvalueindex %HighPer_GUID% 4f971e89-eebd-4455-a8de-9e59040e7347 5ca83367-6e45-459f-a27b-476b1d01c936 1 >> %LogPath% 2>&1
) else (
	ECHO !DATE! !TIME![Log TRACE]  Not NB image, no set Lid Close action >>%LogPath%
)

if exist ACSleepIndex.txt (
	ECHO !DATE! !TIME![Log TRACE]  type ACSleepIndex.txt >>%LogPath%
	type ACSleepIndex.txt >>%LogPath%
	for /f "delims=" %%I in (ACSleepIndex.txt) do (
		ECHO !DATE! !TIME![Log TRACE]  Powercfg.exe -setACvalueindex %HighPer_GUID% 238c9fa8-0aad-41ed-83f4-97be242c8f20 29f6c1db-86da-48c5-9fdb-f2b67b1f44da %%I >> %LogPath% 2>&1
		Powercfg.exe -setACvalueindex %HighPer_GUID% 238c9fa8-0aad-41ed-83f4-97be242c8f20 29f6c1db-86da-48c5-9fdb-f2b67b1f44da %%I >> %LogPath% 2>&1
	)
)
if exist DCSleepIndex.txt (
	ECHO !DATE! !TIME![Log TRACE]  type DCSleepIndex.txt >>%LogPath%
	type DCSleepIndex.txt >>%LogPath%
	for /f "delims=" %%I in (DCSleepIndex.txt) do (
		ECHO !DATE! !TIME![Log TRACE]  Powercfg.exe -setDCvalueindex %HighPer_GUID% 238c9fa8-0aad-41ed-83f4-97be242c8f20 29f6c1db-86da-48c5-9fdb-f2b67b1f44da %%I >> %LogPath% 2>&1
		Powercfg.exe -setDCvalueindex %HighPer_GUID% 238c9fa8-0aad-41ed-83f4-97be242c8f20 29f6c1db-86da-48c5-9fdb-f2b67b1f44da %%I >> %LogPath% 2>&1
	)
)
Powercfg.exe /qh >c:\OEM\Preload\Powercfg_AfterRestore.txt
exit /b 0