@Echo off
SET LogPath=C:\OEM\AcerLogs\%1.log
ECHO.>>%LogPath%
ECHO %DATE% %TIME%[Log START]  ============ %~dpnx0 ============ >> %LogPath%
Pushd "%~dp0"
SETLOCAL ENABLEDELAYEDEXPANSION

set Balanced_GUID=381b4222-f694-41f0-9685-ff5bb260df2e
SET HighPer_GUID=8c5e7fda-e8bf-4a96-9a85-a6e23a8c635c
SET FindingPath=C:\OEM\Preload\Command\PAP\PAP*.INI
if not exist C:\OEM\Preload\Command\PAP\PAP*.INI (
	ECHO %DATE% %TIME%[Log TRACE]  PAP*.ini not found, SET FindingPath=C:\OEM\Preload\Command\POP*.INI >>%LogPath%
	SET FindingPath=C:\OEM\Preload\Command\POP*.INI
)
ECHO %DATE% %TIME%[Log TRACE]  FindingPath is [%FindingPath%] >>%LogPath%
ECHO %DATE% %TIME%[Log TRACE]  call :%1 >>%LogPath%
call :%1

SETLOCAL DISABLEDELAYEDEXPANSION
popd
ECHO %DATE% %TIME%[Log LEAVE]  ============ %~dpnx0 ============ >> %LogPath%
ECHO.>>%LogPath%
exit /b 0




:FirstBoot
ECHO %DATE% %TIME%[Log TRACE]  call Sub_DisableS3_LidCloseNoAction.cmd Restore>>%LogPath%
call Sub_DisableS3_LidCloseNoAction.cmd Restore
exit /b 0



:UserAlaunch
::::	2017/3/16
::::		Cloud image will not exist FirstBoot phase,
::::		discard the DisableS3_LidCloseNoAction feature and active power plan on UserAlaunch
ECHO %DATE% %TIME%[Log TRACE]  reg query HKLM\SOFTWARE\OEM\Metadata /v CloudSku >>%LogPath% 2>&1
reg query HKLM\SOFTWARE\OEM\Metadata /v CloudSku >>%LogPath% 2>&1
for /f "tokens=3 delims= " %%B in ('reg query HKLM\SOFTWARE\OEM\Metadata /v CloudSku ^| find /i "CloudSku"') do set IsCloud=%%B
ECHO %DATE% %TIME%[Log TRACE]  IsCloud=[%IsCloud%]>>%LogPath%
if /i "%IsCloud%" EQU "TRUE" (
	ECHO %DATE% %TIME%[Log TRACE]  This is Cloud image, skip to call Sub_DisableS3_LidCloseNoAction.cmd >>%LogPath%
) else (
	ECHO %DATE% %TIME%[Log TRACE]  This is not Cloud image, call Sub_DisableS3_LidCloseNoAction.cmd Disable>>%LogPath%
	call Sub_DisableS3_LidCloseNoAction.cmd Disable
)
exit /b 0